/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util;

import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.text.DecimalFormat;

public class Format {
    public static char fillChar = (char)32;
    private static final String EOL = System.getProperty("line.separator");
    private static PrintWriter handle = new PrintWriter(new OutputStreamWriter(System.out));
    private static char alignment;
    private static boolean separator;
    private static char base;
    private static boolean scientific;
    private static boolean zeroFill;
    private static int width;
    private static int decimals;
    private static String pattern;

    private Format() {
    }

    public static String format(byte value, String fd) {
        return Format.formatInteger(value, fd, 8);
    }

    public static String format(char value, String fd) {
        return Format.formatInteger(value, fd, 16);
    }

    public static String format(double value, String fd) {
        String s1;
        Format.extractAttributes(fd);
        if (base == 'B') {
            s1 = Long.toBinaryString(Double.doubleToLongBits(value));
            s1 = String.valueOf(Format.repeat(64, '0')) + s1;
            s1 = s1.substring(s1.length() - 64);
        } else if (base == 'X') {
            s1 = Long.toHexString(Double.doubleToLongBits(value));
            s1 = String.valueOf(Format.repeat(16, '0')) + s1;
            s1 = s1.substring(s1.length() - 16);
        } else {
            String string = pattern = decimals != -1 ? "." + Format.repeat(decimals, '0') : ".#";
            pattern = scientific ? "0" + pattern + "E0" : (separator ? "#,##0" + pattern : "0" + pattern);
            s1 = new DecimalFormat(pattern).format(value);
        }
        return Format.size(s1);
    }

    public static String format(float value, String fd) {
        String s1;
        Format.extractAttributes(fd);
        if (base == 'B') {
            s1 = Integer.toBinaryString(Float.floatToIntBits(value));
            s1 = String.valueOf(Format.repeat(32, '0')) + s1;
            s1 = s1.substring(s1.length() - 32);
        } else if (base == 'X') {
            s1 = Integer.toHexString(Float.floatToIntBits(value));
            s1 = String.valueOf(Format.repeat(8, '0')) + s1;
            s1 = s1.substring(s1.length() - 8);
        } else {
            String string = pattern = decimals != -1 ? "." + Format.repeat(decimals, '0') : ".#";
            pattern = scientific ? "0" + pattern + "E0" : (separator ? "#,##0" + pattern : "0" + pattern);
            s1 = new DecimalFormat(pattern).format(value);
        }
        return Format.size(s1);
    }

    public static String format(int value, String fd) {
        return Format.formatInteger(value, fd, 32);
    }

    public static String format(long value, String fd) {
        return Format.formatInteger(value, fd, 64);
    }

    public static String format(short value, String fd) {
        return Format.formatInteger(value, fd, 16);
    }

    private static String formatInteger(long l, String s, int i) {
        String s1;
        Format.extractAttributes(s);
        if (base == 'B') {
            s1 = Long.toBinaryString(l);
            s1 = String.valueOf(Format.repeat(64, '0')) + s1;
            s1 = s1.substring(s1.length() - i);
        } else if (base == 'X') {
            s1 = Long.toHexString(l);
            s1 = String.valueOf(Format.repeat(16, '0')) + s1;
            s1 = s1.substring(s1.length() - i / 4);
        } else if (separator) {
            s1 = new DecimalFormat("#,###").format(l);
        } else {
            s1 = String.valueOf(l);
            if (zeroFill) {
                s1 = String.valueOf(Format.repeat(width - s1.length(), '0')) + s1;
            }
        }
        return Format.size(s1);
    }

    private static void extractAttributes(String s) {
        s = s.toUpperCase();
        alignment = (char)82;
        separator = false;
        base = (char)68;
        scientific = false;
        zeroFill = false;
        width = -1;
        decimals = -1;
        int i = s.indexOf(76, 0);
        if (i > -1) {
            alignment = (char)76;
            s = String.valueOf(s.substring(0, i)) + s.substring(i + 1);
        }
        if ((i = s.indexOf(67, 0)) > -1) {
            alignment = (char)67;
            s = String.valueOf(s.substring(0, i)) + s.substring(i + 1);
        }
        if ((i = s.indexOf(44, 0)) > -1) {
            separator = true;
            pattern = String.valueOf(pattern) + ",###";
            s = String.valueOf(s.substring(0, i)) + s.substring(i + 1);
        }
        if ((i = s.indexOf(88, 0)) > -1) {
            base = (char)88;
            s = String.valueOf(s.substring(0, i)) + s.substring(i + 1);
        } else {
            i = s.indexOf(66, 0);
            if (i > -1) {
                base = (char)66;
                s = String.valueOf(s.substring(0, i)) + s.substring(i + 1);
            }
        }
        i = s.indexOf(83, 0);
        if (i > -1) {
            scientific = true;
            s = String.valueOf(s.substring(0, i)) + s.substring(i + 1);
        }
        if ((i = s.indexOf(90, 0)) > -1) {
            zeroFill = true;
            s = String.valueOf(s.substring(0, i)) + s.substring(i + 1);
        }
        if ((i = s.indexOf(46, 0)) > -1) {
            decimals = Integer.parseInt(s.substring(i + 1));
            s = s.substring(0, i);
        }
        if (s.length() > 0) {
            width = Integer.parseInt(s);
        }
    }

    public static void print(byte value, String fd) {
        handle.print(Format.format(value, fd));
        handle.flush();
    }

    public static void print(char value, String fd) {
        handle.print(Format.format(value, fd));
        handle.flush();
    }

    public static void print(double value, String fd) {
        handle.print(Format.format(value, fd));
        handle.flush();
    }

    public static void print(float value, String fd) {
        handle.print(Format.format(value, fd));
        handle.flush();
    }

    public static void print(int value, String fd) {
        handle.print(Format.format(value, fd));
        handle.flush();
    }

    public static void print(long value, String fd) {
        handle.print(Format.format(value, fd));
        handle.flush();
    }

    public static void print(short value, String fd) {
        handle.print(Format.format(value, fd));
        handle.flush();
    }

    public static void println(byte value, String fd) {
        Format.print(value, fd);
        handle.print(EOL);
        handle.flush();
    }

    public static void println(char value, String fd) {
        Format.print(value, fd);
        handle.print(EOL);
        handle.flush();
    }

    public static void println(double value, String fd) {
        Format.print(value, fd);
        handle.print(EOL);
        handle.flush();
    }

    public static void println(float value, String fd) {
        Format.print(value, fd);
        handle.print(EOL);
        handle.flush();
    }

    public static void println(int value, String fd) {
        Format.print(value, fd);
        handle.print(EOL);
        handle.flush();
    }

    public static void println(long value, String fd) {
        Format.print(value, fd);
        handle.print(EOL);
        handle.flush();
    }

    public static void println(short value, String fd) {
        Format.print(value, fd);
        handle.print(EOL);
        handle.flush();
    }

    private static String size(String s) {
        int i = width - s.length();
        if (alignment == 'R') {
            return String.valueOf(Format.repeat(i, fillChar)) + s;
        }
        if (alignment == 'L') {
            return String.valueOf(s) + Format.repeat(i, fillChar);
        }
        return String.valueOf(Format.repeat(i / 2, fillChar)) + s + Format.repeat(i / 2 + i % 2, fillChar);
    }

    public static String repeat(int times, char c) {
        String s = "";
        int i = 0;
        while (i < times) {
            s = String.valueOf(s) + c;
            ++i;
        }
        return s;
    }
}

